/*
* Most important
* #include "wvtwin.ch"
*/

/*
* This function activate the l3w_fMsgClas and return Button Value Pressed
* but value returned is like MiniGui
*/
FUNCTION l3w_fMsgBox( _cString, _cTitle )
LOCAL _oForm := l3w_fMsgClas():New( _cString, _cTitle, MB_OK, .F., 0, .T. )
LOCAL _nButton := _oForm:Win()
LOCAL _lReturn := .T.
_oForm := NIL
RETURN _lReturn
/*
* This function activate the l3w_fMsgClas with some parameters preconfigured
* but value returned is like MiniGui
*/
FUNCTION l3w_fMsgStop( _cString, _cTitle, _lRevert )
LOCAL _oForm := l3w_fMsgClas():New( _cString, _cTitle, MB_OK, _lRevert, 4, .T. )
LOCAL _nButton := _oForm:Win()
LOCAL _lReturn := .T.
_oForm := NIL
RETURN _lReturn
/*
* This function activate the l3w_fMsgClas with some parameters preconfigured
* but value returned is like MiniGui
*/
FUNCTION l3w_fMsgAlert( _cString, _cTitle, _lRevert )
LOCAL _oForm := l3w_fMsgClas():New( _cString, _cTitle, MB_OK, _lRevert, 3, .T. )
LOCAL _nButton := _oForm:Win()
LOCAL _lReturn := .T.
_oForm := NIL
RETURN _lReturn
/*
* This function activate the l3w_fMsgClas with some parameters preconfigured
* but value returned is like MiniGui
*/
FUNCTION l3w_fMsgHelp( _cString, _cTitle, _lRevert )
LOCAL _oForm := l3w_fMsgClas():New( _cString, _cTitle, MB_OK, _lRevert, 2, .T. )
LOCAL _nButton := _oForm:Win()
LOCAL _lReturn := .T.
_oForm := NIL
RETURN _lReturn
/*
* This function activate the l3w_fMsgClas with some parameters preconfigured
* but value returned is like MiniGui
*/
FUNCTION l3w_fMsgWarn( _cString, _cTitle, _lRevert)
LOCAL _oForm := l3w_fMsgClas():New( _cString, _cTitle, MB_OK, _lRevert, 1, .T. )
LOCAL _nButton := _oForm:Win()
LOCAL _lReturn := .T.
_oForm := NIL
RETURN _lReturn
/*
* This function activate the l3w_fMsgClas with some parameters preconfigured
* but value returned is like MiniGui
*/
FUNCTION l3w_fMsgYesNo( _cString, _cTitle, _lRevert )
LOCAL _oForm := l3w_fMsgClas():New( _cString, _cTitle, MB_YESNO, _lRevert, 3, .T. )
LOCAL _nButton := _oForm:Win()
LOCAL _lReturn := IIF(_nButton==IDYES, .T., .F. )
_oForm := NIL
RETURN _lReturn
/*
* This function activate the l3w_fMsgClas with some parameters preconfigured
* but value returned is like MiniGui
*/
FUNCTION l3w_fMsgRetryCanc( _cString, _cTitle, _lRevert )
LOCAL _oForm := l3w_fMsgClas():New( _cString, _cTitle, MB_RETRYCANCEL, _lRevert, 4, .T. )
LOCAL _nButton := _oForm:Win()
LOCAL _lReturn := IIF(_nButton==IDRETRY, .T., .F. )
_oForm := NIL
RETURN _lReturn
/*
* This function activate the l3w_fMsgClas with some parameters preconfigured
* but value returned is like MiniGui
*/
FUNCTION l3w_fMsgOkCanc( _cString, _cTitle, _lRevert )
LOCAL _oForm := l3w_fMsgClas():New( _cString, _cTitle, MB_OKCANCEL, _lRevert, 3, .T. )
LOCAL _nButton := _oForm:Win()
LOCAL _lReturn := IIF(_nButton==IDOK, .T., .F. )
_oForm := NIL
RETURN _lReturn

/*
*  CLASS l3w_fMsgCls
* Draw, Activate and Process Form; it return the Button Value Pressed
*
* Form Type - buttons - displayed
* #define MB_OK                                     0
* #define MB_OKCANCEL                               1
* #define MB_ABORTRETRYIGNORE                       2
* #define MB_YESNOCANCEL                            3
* #define MB_YESNO                                  4
* #define MB_RETRYCANCEL                            5
* #define MB_CANCELTRYCONTINUE                      6
*
* Button Value returned
* #define IDOK                                      1
* #define IDCANCEL                                  2
* #define IDABORT                                   3
* #define IDRETRY                                   4
* #define IDIGNORE                                  5
* #define IDYES                                     6
* #define IDNO                                      7
* #define IDTRYAGAIN                                10                  // (WINVER >= 0x0500)
* #define IDCONTINUE                                11                  // (WINVER >= 0x0500)
*/
FUNCTION l3w_fMsgClas()
STATIC _oClass
IF _oClass == NIL
 _oClass := HBClass():New("l3wfMsgClas")  // New class
 _oClass:AddClassData("nRetvalue",   IDOK,    "N", HB_OO_CLSTP_PROTECTED )    //Button Value Returned
 _oClass:AddClassData("nWidthWin",   500,     "N", HB_OO_CLSTP_PROTECTED )    //Form Width
 _oClass:AddClassData("nHeightWin",  345,     "N", HB_OO_CLSTP_PROTECTED )    //Form Height
 _oClass:AddClassData("cFontWin",    "Arial", "C", HB_OO_CLSTP_PROTECTED )    //Form Font Name
 _oClass:AddClassData("nFontWin",    10,      "N", HB_OO_CLSTP_PROTECTED )    //Form Font Size

 _oClass:AddClassData("nWidthSign",  48,      "N", HB_OO_CLSTP_PROTECTED )    //Sign Width
 _oClass:AddClassData("nHeightSign", 48,      "N", HB_OO_CLSTP_PROTECTED )    //Sign Height
 _oClass:AddClassData("nRowsign",    5,       "N", HB_OO_CLSTP_PROTECTED )    //Sign Row
 _oClass:AddClassData("nColsign",    200,     "N", HB_OO_CLSTP_PROTECTED )    //Sign Col

 _oClass:AddClassData("nHeightBut",  25,      "N", HB_OO_CLSTP_PROTECTED )    //Button Height
 _oClass:AddClassData("nWidthBut",   80,      "N", HB_OO_CLSTP_PROTECTED )    //Button Width
 _oClass:AddClassData("nRowBut",     270,     "N", HB_OO_CLSTP_PROTECTED )    //Button Row
 _oClass:AddClassData("nColBut",     210,     "N", HB_OO_CLSTP_PROTECTED )    //Button Col
 _oClass:AddClassData("cFontBut",    "Arial", "C", HB_OO_CLSTP_PROTECTED )    //Button Font Name
 _oClass:AddClassData("nFontBut",    10,      "N", HB_OO_CLSTP_PROTECTED )    //Button Font Size

 _oClass:AddClassData("nWidthMsg",   480,     "N", HB_OO_CLSTP_PROTECTED )    //Message Width
 _oClass:AddClassData("nHeightMsg",  200,     "N", HB_OO_CLSTP_PROTECTED )    //Message Height
 _oClass:AddClassData("cFontMsg",    "Arial", "C", HB_OO_CLSTP_PROTECTED )    //Message Font Name
 _oClass:AddClassData("nFontMsg",    10,      "N", HB_OO_CLSTP_PROTECTED )    //Message Font Size
 _oClass:AddClassData("nRowMsg",     60,      "N", HB_OO_CLSTP_PROTECTED )    //Message Row
 _oClass:AddClassData("nColMsg",     10,      "N", HB_OO_CLSTP_PROTECTED )    //Message Col

 _oClass:AddClassData("cMessage",    "",      "C", HB_OO_CLSTP_PROTECTED )    //Text displayed
 _oClass:AddClassData("cTitle",      "",      "C", HB_OO_CLSTP_PROTECTED )    //Form Title
 _oClass:AddClassData("nFormtype",   MB_OK,   "N", HB_OO_CLSTP_PROTECTED )    //Form Type Upon MB_ constants
 _oClass:AddClassData("nSignal",     0,       "N", HB_OO_CLSTP_PROTECTED )    //Form Signal: 0 None, 1 Hand, 2 Question Mark, 3 Alert, 4 Stop
 _oClass:AddClassData("lRevert",     .F.,     "L", HB_OO_CLSTP_PROTECTED )    //Revert focused button

* Your ICON on form
 _oClass:AddClassData("DefIcon",  , , HB_OO_CLSTP_PROTECTED )    //Default Icon Image
* You can add other images, but remember: you must change
 _oClass:AddClassData("DefSign",  , , HB_OO_CLSTP_PROTECTED )    //Default Signal Image
 _oClass:AddClassData("HandSign", , , HB_OO_CLSTP_PROTECTED )    //Hand Signal Image
 _oClass:AddClassData("QuesSign", , , HB_OO_CLSTP_PROTECTED )    //Question Mark Signal Image
 _oClass:AddClassData("AlerSign", , , HB_OO_CLSTP_PROTECTED )    //Alert Signal Image
 _oClass:AddClassData("StopSign", , , HB_OO_CLSTP_PROTECTED )    //Stop Signal Image

* Sounds
 _oClass:AddClassData("lSound" ,     .F.,       "L", HB_OO_CLSTP_PROTECTED )    //.F. None, .T. play Waf
 _oClass:AddClassData("DefWav" , , , HB_OO_CLSTP_PROTECTED )    //Default Wav
 _oClass:AddClassData("HandWav", , , HB_OO_CLSTP_PROTECTED )    //Hand Wav
 _oClass:AddClassData("QuesWav", , , HB_OO_CLSTP_PROTECTED )    //Question Wav
 _oClass:AddClassData("AlerWav", , , HB_OO_CLSTP_PROTECTED )    //Alert Wav
 _oClass:AddClassData("StopWav", , , HB_OO_CLSTP_PROTECTED )    //Stop Wav

 _oClass:AddMethod( "New",      @l3wfMsgClas_new()    )    //Create a new class instance
 _oClass:AddMethod( "Win",      @l3wfMsgClas_win()    )    //Draw Out form
 _oClass:AddMethod( "Signal",   @l3wfMsgClas_signal(), HB_OO_CLSTP_PROTECTED )    //Check and Display Signal if required
 _oClass:AddMethod( "FormType", @l3wfMsgClas_ftype(),  HB_OO_CLSTP_PROTECTED )    //Check Formtype and Activate Buttons required
 _oClass:AddMethod( "TxtOut",   @l3wfMsgClas_txtout(), HB_OO_CLSTP_PROTECTED )    //Check and Display Text Message

 _oClass:AddMethod( "Ok",       @l3wfMsgClas_Ok(),     HB_OO_CLSTP_PROTECTED )    //Button OK pressed
 _oClass:AddMethod( "Cancel",   @l3wfMsgClas_Cancel(), HB_OO_CLSTP_PROTECTED )    //Button CANCEL pressed
 _oClass:AddMethod( "Abort",    @l3wfMsgClas_Abort(),  HB_OO_CLSTP_PROTECTED )    //Button ABORT pressed
 _oClass:AddMethod( "Retry",    @l3wfMsgClas_Retry(),  HB_OO_CLSTP_PROTECTED )    //Button RETRY pressed
 _oClass:AddMethod( "Ignore",   @l3wfMsgClas_Ignore(), HB_OO_CLSTP_PROTECTED )    //Button IGNORE pressed
 _oClass:AddMethod( "Yes",      @l3wfMsgClas_Yes(),    HB_OO_CLSTP_PROTECTED )    //Button YES pressed
 _oClass:AddMethod( "No",       @l3wfMsgClas_No(),     HB_OO_CLSTP_PROTECTED )    //Button NO pressed
 _oClass:AddMethod( "Try",      @l3wfMsgClas_Try(),    HB_OO_CLSTP_PROTECTED )    //Button TRY pressed
 _oClass:AddMethod( "Cont",     @l3wfMsgClas_Cont(),   HB_OO_CLSTP_PROTECTED )    //Button CONTINUE pressed

 _oClass:AddMethod( "Wav",      @l3wfMsgClas_Wav(),    HB_OO_CLSTP_PROTECTED )    //Play Sound from resource

 _oClass:Create()
ENDIF
RETURN _oClass:Instance()
/*
* Create a new class instance
*/
STATIC FUNCTION l3wfMsgClas_new( _cMessage, _cTitle, _nType, _lRevert, _nSignal, _lSound )
LOCAL _oSelf := Qself()
DEFAULT _cMessage := "Undefined message"
DEFAULT _cTitle := "Undefined title"
DEFAULT _nType := MB_OK
DEFAULT _nSignal := 0
DEFAULT _lSound := .T.
DEFAULT _lRevert := .F.
* check parameter before
_oSelf:cMessage := IIF( ( VALTYPE(_cMessage)=="C" .AND. EMPTY(_cMessage) ) .OR. VALTYPE( _cMessage ) != "C" , "Undefined message", ALLTRIM( _cMessage ) )
_oSelf:cTitle   := IIF( ( VALTYPE(_cTitle)=="C" .AND. EMPTY(_cTitle) ) .OR. VALTYPE( _cTitle ) != "C" , "Undefined title", ALLTRIM( _cTitle ) )
* Form type
IF VALTYPE( _nType ) == "N" .AND. ;
 ( _nType==MB_OK .OR. _nType==MB_OKCANCEL .OR. _nType==MB_ABORTRETRYIGNORE .OR. ;
   _nType==MB_YESNOCANCEL .OR. _nType==MB_YESNO .OR. _nType==MB_RETRYCANCEL .OR. _nType==MB_CANCELTRYCONTINUE )
 _oSelf:nFormtype := _nType
ELSE
 _oSelf:nFormtype := MB_OK
ENDIF
* Revert Button focused
_oSelf:lRevert := IIF( VALTYPE( _lRevert ) == "L", _lRevert, .F.)
* If You have added some images, you must change this test in according with parameter and images. At this moment there are 4 images
_oSelf:nSignal := IIF( VALTYPE( _nSignal )=="N" .AND. _nSignal>=0 .AND. _nSignal<=4, _nSignal, 0 )
* You can change image reference here
_oSelf:DefSign := 'L3W_SHAND'
_oSelf:HandSign := 'L3W_SHAND'
_oSelf:QuesSign := 'L3W_SQUESTION'
_oSelf:AlerSign := 'L3W_SALERT'
_oSelf:StopSign := 'L3W_SSTOP'
* Your preferred ICON
_oSelf:DefIcon := 'L3W_L3WICO'
* Sound
_oSelf:lSound := IIF( VALTYPE( _lSound )=="L", _lSound, .F. )
_oSelf:DefWav  := 'L3W_WRING'
_oSelf:HandWav := 'L3W_WHAND'
_oSelf:QuesWav := 'L3W_WQUES'
_oSelf:AlerWav := 'L3W_WALER'
_oSelf:StopWav := 'L3W_WSTOP'
* Check and change nDefault Button Value
IF _oSelf:nFormtype==MB_OK
 _oSelf:nRetvalue := IDOK
ELSEIF _oSelf:nFormtype==MB_OKCANCEL
 _oSelf:nRetvalue := IIF(_oSelf:lRevert==.T., IDCANCEL, IDOK )
ELSEIF _oSelf:nFormtype==MB_ABORTRETRYIGNORE
 _oSelf:nRetvalue := IIF(_oSelf:lRevert==.T., IDIGNORE, IDABORT )
ELSEIF _oSelf:nFormtype==MB_YESNOCANCEL
 _oSelf:nRetvalue := IIF(_oSelf:lRevert==.T., IDYES, IDCANCEL )
ELSEIF _oSelf:nFormtype==MB_YESNO
 _oSelf:nRetvalue := IIF(_oSelf:lRevert==.T., IDNO, IDYES )
ELSEIF _oSelf:nFormtype==MB_RETRYCANCEL
 _oSelf:nRetvalue := IIF(_oSelf:lRevert==.T., IDCANCEL, IDRETRY )
ELSEIF _oSelf:nFormtype==MB_CANCELTRYCONTINUE
 _oSelf:nRetvalue := IIF(_oSelf:lRevert==.T., IDCONTINUE, IDCANCEL )
ENDIF
RETURN _oSelf

/*
* Draw Out form
*/
STATIC FUNCTION l3wfMsgClas_win()
LOCAL _oSelf := Qself()
IF .NOT. IsWindowDefined( l3win0 )
 DEFINE WINDOW l3win0  ;
  AT 0,0  ;
  WIDTH _oSelf:nWidthWin  ;
  HEIGHT _oSelf:nHeightWin  ;
  TITLE _oSelf:cTitle  ;
  ICON _oSelf:DefIcon  ;
  MODAL ;
  NOSIZE ;
  FONT _oSelf:cFontWin ;
  SIZE _oSelf:nFontWin

  DEFINE IMAGE win0_sign
   PARENT l3win0
   ROW _oSelf:nRowsign
   COL _oSelf:nColsign
   WIDTH _oSelf:nWidthSign
   HEIGHT _oSelf:nHeightSign
   PICTURE _oSelf:DefSign
   STRETCH .F.
   VISIBLE .F.
  END IMAGE

  DEFINE EDITBOX win0_mesg
   PARENT l3win0
   ROW _oSelf:nRowMsg
   COL _oSelf:nColMsg
   WIDTH _oSelf:nWidthMsg
   HEIGHT _oSelf:nHeightMsg
   FONTNAME _oSelf:cFontMsg
   FONTSIZE _oSelf:nFontMsg
   TABSTOP .F.
   VISIBLE .T.
   VALUE ""
   READONLY .T.
   VSCROLLBAR .T.
   HSCROLLBAR .F.
  END EDITBOX

*  iniziano  le  definizioni  dei  bottoni
  DEFINE BUTTON  win0_ok
   PARENT l3win0
   ROW _oSelf:nRowBut
   COL _oSelf:nColBut
   CAPTION 'Ok'
   ONCLICK _oSelf:Ok()
   WIDTH _oSelf:nWidthBut
   HEIGHT _oSelf:nHeightBut
   FONTNAME _oSelf:cFontBut
   FONTSIZE _oSelf:nFontBut
   FLAT .T.
   TABSTOP .T.
   VISIBLE .F.
  END  BUTTON

  DEFINE BUTTON win0_canc
   PARENT l3win0
   ROW _oSelf:nRowBut
   COL _oSelf:nColBut
   CAPTION 'Cancel'
   ONCLICK _oSelf:Cancel()
   WIDTH _oSelf:nWidthBut
   HEIGHT _oSelf:nHeightBut
   FONTNAME _oSelf:cFontBut
   FONTSIZE _oSelf:nFontBut
   FLAT .T.
   TABSTOP .T.
   VISIBLE .F.
  END BUTTON

  DEFINE BUTTON win0_abort
   PARENT l3win0
   ROW _oSelf:nRowBut
   COL _oSelf:nColBut
   CAPTION 'Abort'
   ONCLICK _oSelf:Abort()
   WIDTH _oSelf:nWidthBut
   HEIGHT _oSelf:nHeightBut
   FONTNAME _oSelf:cFontBut
   FONTSIZE _oSelf:nFontBut
   FLAT .T.
   TABSTOP .T.
   VISIBLE .F.
  END BUTTON

  DEFINE BUTTON  win0_retry
   PARENT l3win0
   ROW _oSelf:nRowBut
   COL _oSelf:nColBut
   CAPTION 'Retry'
   ONCLICK _oSelf:Retry()
   WIDTH _oSelf:nWidthBut
   HEIGHT _oSelf:nHeightBut
   FONTNAME _oSelf:cFontBut
   FONTSIZE _oSelf:nFontBut
   FLAT .T.
   TABSTOP .T.
   VISIBLE .F.
  END BUTTON

  DEFINE BUTTON win0_ignore
   PARENT l3win0
   ROW _oSelf:nRowBut
   COL _oSelf:nColBut
   CAPTION 'Ignore'
   ONCLICK _oSelf:Ignore()
   WIDTH _oSelf:nWidthBut
   HEIGHT _oSelf:nHeightBut
   FONTNAME _oSelf:cFontBut
   FONTSIZE _oSelf:nFontBut
   FLAT .T.
   TABSTOP .T.
   VISIBLE .F.
  END BUTTON

  DEFINE BUTTON win0_yes
   PARENT l3win0
   ROW _oSelf:nRowBut
   COL _oSelf:nColBut
   CAPTION 'Yes'
   ONCLICK _oSelf:Yes()
   WIDTH _oSelf:nWidthBut
   HEIGHT _oSelf:nHeightBut
   FONTNAME _oSelf:cFontBut
   FONTSIZE _oSelf:nFontBut
   FLAT .T.
   TABSTOP .T.
   VISIBLE .F.
  END BUTTON

  DEFINE BUTTON win0_no
   PARENT l3win0
   ROW _oSelf:nRowBut
   COL _oSelf:nColBut
   CAPTION 'No'
   ONCLICK _oSelf:No()
   WIDTH _oSelf:nWidthBut
   HEIGHT _oSelf:nHeightBut
   FONTNAME _oSelf:cFontBut
   FONTSIZE _oSelf:nFontBut
   FLAT .T.
   TABSTOP .T.
   VISIBLE .F.
  END BUTTON

  DEFINE BUTTON win0_try
   PARENT l3win0
   ROW _oSelf:nRowBut
   COL _oSelf:nColBut
   CAPTION 'Try'
   ONCLICK _oSelf:Try()
   WIDTH _oSelf:nWidthBut
   HEIGHT _oSelf:nHeightBut
   FONTNAME _oSelf:cFontBut
   FONTSIZE _oSelf:nFontBut
   FLAT .T.
   TABSTOP .T.
   VISIBLE .F.
  END BUTTON

  DEFINE BUTTON win0_cont
   PARENT l3win0
   ROW _oSelf:nRowBut
   COL _oSelf:nColBut
   CAPTION 'Continue'
   ONCLICK _oSelf:Cont()
   WIDTH _oSelf:nWidthBut
   HEIGHT _oSelf:nHeightBut
   FONTNAME _oSelf:cFontBut
   FONTSIZE _oSelf:nFontBut
   FLAT .T.
   TABSTOP .T.
   VISIBLE .F.
  END BUTTON

 END WINDOW
 _oSelf:Wav()
 _oSelf:Signal()
 _oSelf:FormType()
 _oSelf:TxtOut()
 CENTER WINDOW l3win0
 ACTIVATE WINDOW l3win0
ENDIF
RETURN _oSelf:nRetvalue

/*
* Play Sound
*/
STATIC FUNCTION l3wfMsgClas_Wav()
LOCAL _oSelf := Qself()
IF _oSelf:lSound
 DO CASE
  CASE _oSelf:nSignal == 1
   PLAY WAVE _oSelf:HandWav FROM RESOURCE
  CASE _oSelf:nSignal == 2
   PLAY WAVE _oSelf:QuesWav FROM RESOURCE
  CASE _oSelf:nSignal == 3
   PLAY WAVE _oSelf:AlerWav FROM RESOURCE
  CASE _oSelf:nSignal == 4
   PLAY WAVE _oSelf:StopWav FROM RESOURCE
  OTHERWISE
   PLAY WAVE _oSelf:DefWav FROM RESOURCE
 ENDCASE
ENDIF
RETURN _oSelf

/*
* Check and Display Signal if required
*/
STATIC FUNCTION l3wfMsgClas_signal()
LOCAL _oSelf := Qself()
DO CASE
 CASE _oSelf:nSignal == 1
  l3win0.win0_sign.Picture := _oSelf:HandSign
  l3win0.win0_sign.Visible := .T.
 CASE _oSelf:nSignal == 2
  l3win0.win0_sign.Picture := _oSelf:QuesSign
  l3win0.win0_sign.Visible := .T.
 CASE _oSelf:nSignal == 3
  l3win0.win0_sign.Picture := _oSelf:AlerSign
  l3win0.win0_sign.Visible := .T.
 CASE _oSelf:nSignal == 4
  l3win0.win0_sign.Picture := _oSelf:StopSign
  l3win0.win0_sign.Visible := .T.
 OTHERWISE
  l3win0.win0_sign.Visible := .F.
ENDCASE
RETURN _oSelf

/*
* Check Formtype and Activate Buttons required
*/
STATIC FUNCTION l3wfMsgClas_ftype()
LOCAL _oSelf := Qself()
DO CASE
 CASE _oSelf:nFormtype == MB_CANCELTRYCONTINUE
  SetProperty ( 'l3win0' , 'win0_canc' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_canc' , 'Col' , 50 )
  SetProperty ( 'l3win0' , 'win0_try' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_try' , 'Col' , 210 )
  SetProperty ( 'l3win0' , 'win0_cont' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_cont' , 'Col' , 370 )
  l3win0.win0_canc.SetFocus
  IF _oSelf:lRevert
   l3win0.win0_cont.SetFocus
  ENDIF
 CASE _oSelf:nFormtype == MB_YESNOCANCEL
  SetProperty ( 'l3win0' , 'win0_yes' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_yes' , 'Col' , 50 )
  SetProperty ( 'l3win0' , 'win0_no' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_no' , 'Col' , 210 )
  SetProperty ( 'l3win0' , 'win0_canc' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_canc' , 'Col' , 370 )
  l3win0.win0_yes.SetFocus
  IF _oSelf:lRevert
   l3win0.win0_canc.SetFocus
  ENDIF
 CASE _oSelf:nFormtype == MB_RETRYCANCEL
  SetProperty ( 'l3win0' , 'win0_retry' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_retry' , 'Col' , 130 )
  SetProperty ( 'l3win0' , 'win0_canc' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_canc' , 'Col' , 290 )
  l3win0.win0_retry.SetFocus
  IF _oSelf:lRevert
   l3win0.win0_canc.SetFocus
  ENDIF
 CASE _oSelf:nFormtype == MB_YESNO
  SetProperty ( 'l3win0' , 'win0_yes' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_yes' , 'Col' , 130 )
  SetProperty ( 'l3win0' , 'win0_no' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_no' , 'Col' , 290 )
  l3win0.win0_yes.SetFocus
  IF _oSelf:lRevert
   l3win0.win0_no.SetFocus
  ENDIF
 CASE _oSelf:nFormtype == MB_YESNOCANCEL
  SetProperty ( 'l3win0' , 'win0_yes' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_yes' , 'Col' , 50 )
  SetProperty ( 'l3win0' , 'win0_no' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_no' , 'Col' , 210 )
  SetProperty ( 'l3win0' , 'win0_canc' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_canc' , 'Col' , 370 )
  l3win0.win0_yes.SetFocus
  IF _oSelf:lRevert
   l3win0.win0_canc.SetFocus
  ENDIF
 CASE _oSelf:nFormtype == MB_ABORTRETRYIGNORE
  SetProperty ( 'l3win0' , 'win0_abort' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_abort' , 'Col' , 50 )
  SetProperty ( 'l3win0' , 'win0_retry' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_retry' , 'Col' , 210 )
  SetProperty ( 'l3win0' , 'win0_ignore' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_ignore' , 'Col' , 370 )
  l3win0.win0_abort.SetFocus
  IF _oSelf:lRevert
   l3win0.win0_ignore.SetFocus
  ENDIF
 CASE _oSelf:nFormtype == MB_OKCANCEL
  SetProperty ( 'l3win0' , 'win0_ok' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_ok' , 'Col' , 130 )
  SetProperty ( 'l3win0' , 'win0_canc' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_canc' , 'Col' , 290 )
  l3win0.win0_ok.SetFocus
  IF _oSelf:lRevert
   l3win0.win0_canc.SetFocus
  ENDIF
 OTHERWISE
  SetProperty ( 'l3win0' , 'win0_ok' , 'Visible' , .T. )
  SetProperty ( 'l3win0' , 'win0_ok' , 'Col' , 210 )
  l3win0.win0_ok.SetFocus
ENDCASE
RETURN _oSelf

/*
* Check and Display Text Message
*/
STATIC FUNCTION l3wfMsgClas_txtout()
LOCAL _oSelf := Qself()
SetProperty ( 'l3win0' , 'win0_mesg' , 'Value' , _oSelf:cMessage )
RETURN _oSelf

/*
* Button OK pressed
*/
STATIC FUNCTION l3wfMsgClas_Ok()
LOCAL _oSelf := Qself()
_oSelf:nRetvalue := IDOK
l3win0.Release
RETURN _oSelf

/*
* Button Cancel pressed
*/
STATIC FUNCTION l3wfMsgClas_Cancel()
LOCAL _oSelf := Qself()
_oSelf:nRetvalue := IDCANCEL
l3win0.Release
RETURN _oSelf

/*
* Button Abort pressed
*/
STATIC FUNCTION l3wfMsgClas_Abort()
LOCAL _oSelf := Qself()
_oSelf:nRetvalue := IDABORT
l3win0.Release
RETURN _oSelf

/*
* Button Retry pressed
*/
STATIC FUNCTION l3wfMsgClas_Retry()
LOCAL _oSelf := Qself()
_oSelf:nRetvalue := IDRETRY
l3win0.Release
RETURN _oSelf

/*
* Button Ignore pressed
*/
STATIC FUNCTION l3wfMsgClas_Ignore()
LOCAL _oSelf := Qself()
_oSelf:nRetvalue := IDIGNORE
l3win0.Release
RETURN _oSelf

/*
* Button Yes pressed
*/
STATIC FUNCTION l3wfMsgClas_Yes()
LOCAL _oSelf := Qself()
_oSelf:nRetvalue := IDYES
l3win0.Release
RETURN _oSelf

/*
* Button No pressed
*/
STATIC FUNCTION l3wfMsgClas_No()
LOCAL _oSelf := Qself()
_oSelf:nRetvalue := IDNO
l3win0.Release
RETURN _oSelf

/*
* Button Try pressed
*/
STATIC FUNCTION l3wfMsgClas_Try()
LOCAL _oSelf := Qself()
_oSelf:nRetvalue := IDTRYAGAIN
l3win0.Release
RETURN _oSelf

/*
* Button Continue pressed
*/
STATIC FUNCTION l3wfMsgClas_Cont()
LOCAL _oSelf := Qself()
_oSelf:nRetvalue := IDCONTINUE
l3win0.Release
RETURN _oSelf
