#include "minigui.ch"
/*
* Most important
*/
#include "hboo.ch"
#include "wvtwin.ch"

#include "l3w_msgout.prg"

FUNCTION main()

DEFINE WINDOW p000win ;
 AT 0,0 ;
 WIDTH 800 ;
 HEIGHT 640 ;
 TITLE 'Testing program' ;
 ICON 'L3W_L3WICO' ;
 MAIN ;
 FONT "Arial" ;
 SIZE 12

 DEFINE MAIN MENU
  DEFINE POPUP '&File'
   MENUITEM 'e&Xit' ACTION p000win.Release
  END POPUP
  DEFINE POPUP '&1 Base'
   MENUITEM '&1 OK, NoSign, Sound'   ACTION p001()
   MENUITEM '&2 OK, Hand, Sound'     ACTION p002()
   MENUITEM '&3 OK, Help, Sound'     ACTION p003()
   MENUITEM '&4 OK, Alert, Sound'    ACTION p004()
   MENUITEM '&5 OK, Stop, Sound'     ACTION p005()
   MENUITEM '&6 OK, NoSign, NoSound' ACTION p006()
  END POPUP
  DEFINE POPUP '&2 More Button'
   MENUITEM '&1 OkCancel'          ACTION p101()
   MENUITEM '&2 AbortRetryIgnore'  ACTION p102()
   MENUITEM '&3 YesNoCancel'       ACTION p103()
   MENUITEM '&4 YesNo'             ACTION p104()
   MENUITEM '&5 RetryCancel'       ACTION p105()
   MENUITEM '&5 CancelTryContinue' ACTION p106()
  END POPUP
  DEFINE POPUP '&3 Like MiniGui msg...'
   MENUITEM '&1 Stop'              ACTION p201()
   MENUITEM '&2 Info'              ACTION p202()
   MENUITEM '&3 Exclamation'       ACTION p203()
  END POPUP
 END MENU

END WINDOW
CENTER WINDOW p000win
ACTIVATE WINDOW p000win
RETURN NIL

/*
* parameters (no ones is mandatory)
*
* #1 Message text (can be omitted, an alternative will be displayed)
* #2 Window title (can be omitted, an alternative will be displayed)
* #3 like defined in wvtwin.ch, can be on of these:
*    MB_OK                                     0  (default)
*    MB_OKCANCEL                               1
*    MB_ABORTRETRYIGNORE                       2
*    MB_YESNOCANCEL                            3
*    MB_YESNO                                  4
*    MB_RETRYCANCEL                            5
*    MB_CANCELTRYCONTINUE                      6
* #4 can be .F. (default) or .T. to revert the default button
* #5 signal. Can be a value from 0 to 4
*    0 - not signal (default)
*    1 - Hand
*    2 - Question mark
*    3 - Alert
*    4 - Stop
* #6 can be .F. or .T. (default) to listen a sound, but about the sign displayed or not (default sound)
*/
STATIC FUNCTION p001()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL lRevert := .F.
LOCAL nSign := 0
LOCAL lSound := .T.
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_OK, lRevert, nSign, lSound )
LOCAL nButton := oForm:Win()
* msgStop everytime helpful
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &2 OK, Hand, Sound
***************************************
STATIC FUNCTION p002()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL lRevert := .F.
LOCAL nSign := 1
LOCAL lSound := .T.
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_OK, lRevert, nSign, lSound )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &3 OK, Help, Sound
***************************************
STATIC FUNCTION p003()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL lRevert := .F.
LOCAL nSign := 2
LOCAL lSound := .T.
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_OK, lRevert, nSign, lSound )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &4 OK, Alert, Sound
***************************************
STATIC FUNCTION p004()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL lRevert := .F.
LOCAL nSign := 3
LOCAL lSound := .T.
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_OK, lRevert, nSign, lSound )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &5 OK, Stop, Sound
***************************************
STATIC FUNCTION p005()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL lRevert := .F.
LOCAL nSign := 4
LOCAL lSound := .T.
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_OK, lRevert, nSign, lSound )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &6 OK, NoSing, NoSound
***************************************
STATIC FUNCTION p006()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL lRevert := .F.
LOCAL nSign := 0
LOCAL lSound := .F.
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_OK, lRevert, nSign, lSound )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &1 More MB_OKCANCEL
***************************************
STATIC FUNCTION p101()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_OKCANCEL )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &2 More MB_ABORTRETRYIGNORE
***************************************
STATIC FUNCTION p102()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_ABORTRETRYIGNORE )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &3 More MB_YESNOCANCEL
***************************************
STATIC FUNCTION p103()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_YESNOCANCEL )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &4 More MB_YESNO
***************************************
STATIC FUNCTION p104()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_YESNO )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &5 More MB_RETRYCANCEL
***************************************
STATIC FUNCTION p105()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_RETRYCANCEL )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* &6 More MB_CANCELTRYCONTINUE
***************************************
STATIC FUNCTION p106()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!"
LOCAL cTitle := "This is a TITLE"
LOCAL oForm := l3w_fMsgClas():New( cMsg, cTitle, MB_CANCELTRYCONTINUE )
LOCAL nButton := oForm:Win()
MSGSTOP("Button pressed " + STR(nButton) )
oForm := NIL
RETURN NIL

***************************************
* Like MiniGui msg...
***************************************
STATIC FUNCTION p201()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!" + HB_OSNEWLINE() + "Like msgStop"
LOCAL cTitle := "This is a TITLE"
LOCAL lValue := l3w_fMsgStop( cMsg, cTitle )
MSGSTOP("Returned " + LTOC(lValue) )
RETURN NIL

***************************************
* Like MiniGui msg...
***************************************
STATIC FUNCTION p202()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!" + HB_OSNEWLINE() + "Like msgInfo"
LOCAL cTitle := "This is a TITLE"
LOCAL lValue := l3w_fMsgWarn( cMsg, cTitle )
MSGINFO("Returned " + LTOC(lValue) )
RETURN NIL

***************************************
* Like MiniGui msg...
***************************************
STATIC FUNCTION p203()
LOCAL cMsg := "This is a simple test." + HB_OSNEWLINE() + "I hope helpful!" + HB_OSNEWLINE() + "Like msgExclamation"
LOCAL cTitle := "This is a TITLE"
LOCAL lValue := l3w_fMsgAlert( cMsg, cTitle )
MSGEXCLAMATION("Returned " + LTOC(lValue) )
RETURN NIL
